<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_OrderedTypedPrice1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_OrderedTypedPrice1 extends AbstractStructArrayBase
{
    /**
     * The ChildA
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_OrderedTypedPrice[]
     */
    public $ChildA;
    /**
     * Constructor method for ArrayOfJPSOAP_OrderedTypedPrice1
     * @uses ArrayOfJPSOAP_OrderedTypedPrice1::setChildA()
     * @param \StructType\JPSOAP_OrderedTypedPrice[] $childA
     */
    public function __construct(array $childA = array())
    {
        $this
            ->setChildA($childA);
    }
    /**
     * Get ChildA value
     * @return \StructType\JPSOAP_OrderedTypedPrice[]|null
     */
    public function getChildA()
    {
        return $this->ChildA;
    }
    /**
     * Set ChildA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedTypedPrice[] $childA
     * @return \ArrayType\ArrayOfJPSOAP_OrderedTypedPrice1
     */
    public function setChildA(array $childA = array())
    {
        foreach ($childA as $arrayOfJPSOAP_OrderedTypedPrice1ChildAItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_OrderedTypedPrice1ChildAItem instanceof \StructType\JPSOAP_OrderedTypedPrice) {
                throw new \InvalidArgumentException(sprintf('The ChildA property can only contain items of \StructType\JPSOAP_OrderedTypedPrice, "%s" given', is_object($arrayOfJPSOAP_OrderedTypedPrice1ChildAItem) ? get_class($arrayOfJPSOAP_OrderedTypedPrice1ChildAItem) : gettype($arrayOfJPSOAP_OrderedTypedPrice1ChildAItem)), __LINE__);
            }
        }
        $this->ChildA = $childA;
        return $this;
    }
    /**
     * Add item to ChildA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedTypedPrice $item
     * @return \ArrayType\ArrayOfJPSOAP_OrderedTypedPrice1
     */
    public function addToChildA(\StructType\JPSOAP_OrderedTypedPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_OrderedTypedPrice) {
            throw new \InvalidArgumentException(sprintf('The ChildA property can only contain items of \StructType\JPSOAP_OrderedTypedPrice, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ChildA[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_OrderedTypedPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildA
     */
    public function getAttributeName()
    {
        return 'ChildA';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_OrderedTypedPrice1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
